// InjectDll.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

int err;

BOOL WINAPI EjectDll(DWORD dwProcessId, LPWSTR dllFileName)
{
	HANDLE hSnapshot = INVALID_HANDLE_VALUE, hProcess = NULL, hThread = NULL;
	MODULEENTRY32 me;
	BOOL bFound = FALSE, bResult = FALSE;
	PTHREAD_START_ROUTINE pfnThreadRtn = NULL;
	if ((hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessId))!= INVALID_HANDLE_VALUE)
	{
		me.dwSize = sizeof(MODULEENTRY32);
		if (Module32First(hSnapshot, &me))
		{
			do
			{
				if (_wcsicmp(me.szModule, dllFileName)==0||
					_wcsicmp(me.szExePath, dllFileName)==0)
				{
					bFound = TRUE;
					break;
				}
			}
			while (Module32Next(hSnapshot, &me));
			if (bFound)
			{
				if ((hProcess = OpenProcess(PROCESS_CREATE_THREAD| PROCESS_VM_OPERATION, FALSE, dwProcessId)) != NULL)
				{					
					if ((pfnThreadRtn = (PTHREAD_START_ROUTINE)GetProcAddress(GetModuleHandle(L"Kernel32"), "FreeLibrary")) != NULL)
					{
						if ((hThread = CreateRemoteThread(hProcess, NULL, 0, pfnThreadRtn, me.modBaseAddr, 0, NULL))!= NULL)
						{
							WaitForSingleObject(hThread, INFINITE);
							bResult = TRUE;
							//CloseHandle(hThread);
						}
					}			
					CloseHandle(hProcess);
				}
			}			
		}
		else
		{
			err = GetLastError();
		}
		CloseHandle(hSnapshot);
	}
	return bResult;
}


BOOL WINAPI InjectDll(DWORD dwProcessId, LPWSTR dllFileName)
{
	BOOL result = FALSE;	

	HANDLE hProcess = NULL, hThread = NULL;
	LPTSTR fileNameRemote = NULL;
	int nameSize = 0;
	PTHREAD_START_ROUTINE pfnThreadRtn = NULL;
	HINSTANCE hInstance = NULL;

	if ((hProcess = OpenProcess(PROCESS_CREATE_THREAD| PROCESS_VM_OPERATION |
		PROCESS_VM_WRITE, FALSE, dwProcessId)) != NULL)
	{		
		nameSize = (wcslen(dllFileName) + 1) * sizeof(WCHAR);
		if ((fileNameRemote = (LPWSTR)VirtualAllocEx(hProcess, NULL, nameSize, MEM_COMMIT, PAGE_READWRITE))!= NULL)
		{
			if (WriteProcessMemory(hProcess, (LPVOID)fileNameRemote, (LPVOID)dllFileName, nameSize, NULL))
			{
				//if ((hInstance = GetModuleHandle(L"kernal32"
				if ((pfnThreadRtn = (PTHREAD_START_ROUTINE)GetProcAddress(GetModuleHandle(L"Kernel32"), "LoadLibraryW")) != NULL)
				{
					if ((hThread = CreateRemoteThread(hProcess, NULL, 0, pfnThreadRtn, fileNameRemote, 0, NULL))!= NULL)
					{
						WaitForSingleObject(hThread, INFINITE);
						result = TRUE;
						//CloseHandle(hThread);
					}
				}
			}
			VirtualFreeEx(hProcess, fileNameRemote, nameSize, MEM_RELEASE);
		}
		
		CloseHandle(hProcess);
	}
	return result;
}

BOOL GetProcessList() 
{ 
    HANDLE         hProcessSnap = NULL; 
    BOOL           bRet      = FALSE; 
    PROCESSENTRY32 pe32      = {0}; 
 
    if ((hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0))!= INVALID_HANDLE_VALUE)
	{
		pe32.dwSize = sizeof(PROCESSENTRY32);  
		if (Process32First(hProcessSnap, &pe32)) 
		{  
			do 
			{ 	
				if (pe32.dwSize != sizeof(PROCESSENTRY32))
				{
					pe32.dwSize = sizeof(PROCESSENTRY32); 
					//break;
				}
			} 
			while (Process32Next(hProcessSnap, &pe32)); 
			err = GetLastError();
			bRet = TRUE; 
		} 
		CloseHandle (hProcessSnap); 
	}
	return bRet; 
} 

/*
BOOL Dlg_OnInitDialog(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	return TRUE;
}


BOOL Dlg_OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	WORD id;
	WCHAR dllFileName[MAX_PATH];
	DWORD processId, nameLength;
	BOOL bTranslated = FALSE;
	id = LOWORD(wParam);
	processId = GetDlgItemInt(hwnd, IDC_PROCESSIDEDIT, &bTranslated, FALSE);
	nameLength = GetDlgItemText(hwnd, IDC_DLLNAMEEDIT, dllFileName, MAX_PATH - 1);

	switch (id)
	{
	case IDC_INJECTBTN:
		if (bTranslated && nameLength)
		{
			InjectDll(processId, dllFileName);
		}

		break;
	case IDC_EJECTBTN:
		if (bTranslated && nameLength)
		{
			EjectDll(processId, dllFileName);
		}
		break;
	case IDC_FINDPROCESSID:
		if (nameLength>0)
		{
			if (GetProcessId(processId, L"explorer.exe"))
			{
				SetDlgItemInt(hwnd, IDC_PROCESSIDEDIT, processId, FALSE);
			}
		}
		break;
	}

	return TRUE;
}


INT_PTR WINAPI Dlg_Proc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		return Dlg_OnInitDialog(hwnd, wParam, lParam);
		break;
	case WM_COMMAND:
		return Dlg_OnCommand(hwnd, wParam, lParam);
		break;
	case WM_CLOSE:
		EndDialog(hwnd, 1);
		return TRUE;
		break;
	}
	return FALSE;
}
*/


BOOL stopProcess()
{
	BOOL  bRes = FALSE;
	DWORD processId;
	if (GetProcessId(processId, TargetProcessName))
	{
		if (EjectDll(processId, MyPeekDllName))
		{
			bRes =TRUE;
		}
	}
	return bRes;
}



#if 0
BOOL runProcess(HINSTANCE hInstance)
{
	BOOL  bRes = FALSE;
	LPVOID pRes;
	DWORD resSize;
	HANDLE hFile = INVALID_HANDLE_VALUE;
	WCHAR szFileName[MY_MAX_PATH];
	DWORD bytesWritten = 0;	
	DWORD processId;

	if (loadMyResource(hInstance, L"dll", IDR_MYDLL, pRes, resSize))
	{
		if (createTempFileFromImage(MyPeekDllName, szFileName, pRes, resSize))
		{
			if (GetProcessId(processId, L"explorer.exe"))
			{
				if (InjectDll(processId, szFileName))
				{
					bRes =TRUE;
				}
			}
		}		
	}
	return bRes;
}
#else
BOOL runProcess()
{
	BOOL  bRes = FALSE;
	DWORD processId;
	LPWSTR  ptr = NULL;
	WCHAR dllFullFileName[MY_MAX_PATH];
	
	if (GetProcessId(processId, TargetProcessName))
	{
		if (GetModuleFileName(NULL, dllFullFileName, MY_MAX_PATH))
		{
			if ((ptr = wcsrchr(dllFullFileName, '\\'))!= NULL)
			{
				ptr ++;
				*ptr = L'\0';
				wcscat(dllFullFileName, MyPeekDllName);
				
				if (InjectDll(processId, dllFullFileName))
				{
					bRes =TRUE;
				}
			}
		}
	}
	return bRes;
}
#endif



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	int counter = 0;
	if (! stopProcess())
	{
		if (runProcess())
		{
			//write to log??
			/*
			while (counter <100)
			{
				counter ++;
				Sleep(1000);
			}
			*/
		}
	}

	/*
	int argc;
	enum OpType
	{OP_INSTALL, OP_UNINSTALL, OP_ERROR};
	OpType opType = OP_ERROR;
	LPWSTR* argv;
	if ((argv = CommandLineToArgvW(GetCommandLineW(), &argc))!= NULL)
	{
		if (argc == 1)
		{
			opType = OP_INSTALL;
		}
		if (argc == 2)
		{
			if (wcsicmp(argv[1], L"install")==0)
			{
				opType = OP_INSTALL;
			}
			else
			{
				if (wcsicmp(argv[1], L"uninstall")==0)
				{
					opType = OP_UNINSTALL;
				}
			}
		}
		switch (opType)
		{
		case OP_INSTALL:
			runProcess();
			break;
		case OP_UNINSTALL:
			stopProcess();
			break;
		case OP_ERROR:
			// nothing now
			break;
		}
	}
*/

	//GetProcessList () ;

	//runProcess(hInstance);
	//stopProcess();

	/*
	
	if (DialogBox(hInstance, MAKEINTRESOURCE(IDD_CONTROLDLG), NULL, Dlg_Proc)!=0)
	{
		int err = GetLastError();
	}
	*/
	

 	// TODO: Place code here.
	//if (InjectDll(GetCurrentProcessId(), L"MyDll.dll"))
	//if ((hWin = FindWindow(L"IEXPLORE.EXE", L"IEXPLORE.EXE"))!= NULL)
	//DWORD processId = GetCurrentProcessId();
/*
		if (InjectDll(1432, L"f:\\MyPeekDll.dll"))
		{
			//MessageBox(NULL, L"Inject dll ok", L"Inject dll", MB_OK);
		}
*/

	/*
	HANDLE hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, 3428);
	if (hProcess)
	{
		checkModule((HINSTANCE)hProcess);
	}
	*/
	//GetProcessList();
	return 0;
}



